-- -*-Text -*-
{
module PCFormula(Formula(..),parseFormula,parse)
where
import Char
import PCTokens
}
%name parseFormula

%tokentype { Token }

%token 
        not		{ TokNeg }
	or		{ TokDisj }
	var		{ TokVar $$ }
	and		{ TokConj }
	imp 		{ TokImp  }
        equiv		{ TokEquiv}
        '('   		{ TokOpen }
        ')'  		{ TokClose}

--%left not
--%left and or
%left imp equiv
%left and or
%left not
%%

Formula : var				{ Var $1 }
	| not Formula			{ Neg $2 }
	| '(' not Formula ')'		{ Neg $3 }
	| '(' Formula and Formula ')'	{ Conj $2 $4 }
	| Formula and Formula	  	{ Conj $1 $3 }
	| '(' Formula or Formula ')'	{ Disj $2 $4 }
	| Formula or Formula	 	{ Disj $1 $3 }
	| '(' Formula imp Formula ')'	{ Imp $2 $4 }
	| Formula imp Formula		{ Imp $1 $3 }
	| '(' Formula equiv Formula ')'	{ Equiv $2 $4 }
	| Formula equiv Formula 	{ Equiv $1 $3 }

{

happyError :: [Token] -> a
happyError _ = error ("Parse error\n")


data Formula = 
  Var String |
  Neg Formula |
  Disj Formula Formula |
  Conj Formula Formula |
  Imp Formula Formula |
  Equiv Formula Formula 
 deriving(Eq,Read,Show)

parse = parseFormula . alexScanTokens


                                        

}
